package andromedajade.demo;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import andromeda.core.AID;
import andromedajade.demo.R;


public class agentGUI extends Activity {
	
	public int prueba=0;
	TextView text;
	private Intent initAgent =null;

	private ArrayList<twoString> Items;
	private twoLineAdapter aa;
	private ListView myListView;
	
	public RxEvent listerEvent = new RxEvent();
	private IntentFilter filterView = new IntentFilter("android.Andromeda.VIEW");
	private IntentFilter filterView1 = new IntentFilter("android.Andromeda.PROGRESS");
	
	static public String IP = null;
    static public String Content = "test:1000";
	static public String value = null;
	static public String AgentName = null;
	static public AID agentJADE = null;
	
	private ProgressDialog dialog =null;
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		IP = this.getIntent().getStringExtra("IPvalue");
		AgentName = this.getIntent().getStringExtra("AgentName");
		
		//no activate mDNS (discovery) => still does not work on some HTC phones 
		//agent address in JADE PLATFORM 
		AID agentReceiver = new AID();
		agentReceiver.setName(AgentName+"@black:1099/JADE");
		agentReceiver.addAddresses("http://"+IP+":7778/acc");
		agentJADE = agentReceiver;
		
		initAgent = new Intent(this, agente.class); 
		startService(initAgent);

		mLockScreenRotation();
		
		Log.i("AGENT", "Agent: " +AgentName+ " ip: " + IP);
		TextView title= (TextView) findViewById(R.id.title);
		title.setText(title.getText().toString()+  " " +  AgentName);
		
		final EditText valor= (EditText) findViewById(R.id.myoffer);
		final Button clientButton = (Button)findViewById(R.id.btn_cap1);
		clientButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
				//activar la capacidad
				String myoffer = valor.getText().toString();
				if (myoffer.contentEquals("")){
					Toast.makeText(agentGUI.this, "Error in Offer", Toast.LENGTH_LONG).show();
				}else{
					try{
					    Double.parseDouble(myoffer);
					    value = myoffer;
					    sendBroadcast(new Intent("android.Andromeda.SECONDROUND"));
					    clientButton.setEnabled(false);
					}
					catch (NumberFormatException e){
						valor.getText().clear();
						Toast.makeText(agentGUI.this, "Error in Offer", Toast.LENGTH_LONG).show();
					}	
				}
				 	
			}
		});


		Items= new ArrayList<twoString>();    

		//Registramos los broadcastReceivers
		registerReceiver(listerEvent, filterView);
		registerReceiver(listerEvent, filterView1);

		myListView = (ListView)findViewById(R.id.L_feeds);       

		aa = new twoLineAdapter(this, R.layout.two_text, Items);
		myListView.setAdapter(aa);    

		Items.add(0, new twoString("PRODUCTS/ITEMS","Best Price"));
		aa.notifyDataSetChanged();
		
		
	}    

    //Events Receiver 
	public class RxEvent extends BroadcastReceiver {
		private AlertDialog alertDialog;

		@Override
		public void onReceive(Context context, Intent intent) {
			//eventos para mostrar el progreso
			if (intent.getAction().contentEquals("android.Andromeda.PROGRESS")){
				if (intent.getStringExtra("value").contains("on")){
					dialog = ProgressDialog.show(agentGUI.this, "", 
	                        intent.getStringExtra("message"), true);
				} else if (intent.getStringExtra("value").contains("off")){
					dialog.dismiss();
				    
				} else if (intent.getStringExtra("value").contains("win")) {
					alertDialog = new AlertDialog.Builder(agentGUI.this).create();
				    alertDialog.setTitle("Results Second Round Bids");
				    alertDialog.setIcon(R.drawable.icon1);
				    alertDialog.setMessage(intent.getStringExtra("message"));
				    alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
				      public void onClick(DialogInterface dialog, int which) {
				        return;
				    } });
				    alertDialog.show();
				}
			
		    //Eventos para "dibujar" en pantalla	
			} else if (intent.getAction().contentEquals("android.Andromeda.VIEW")){
				Content= intent.getStringExtra("content");

				String[] parts = Content.split(":");
				String xgoods = parts[0].substring(parts[0].indexOf("[")+1, parts[0].indexOf("]"));
				String[] goods = xgoods.split(",");


				Double price = Double.parseDouble(parts[1]);
				price = price*(-1);  //convert positive

				Double total = 0.0;
				DecimalFormat df = new DecimalFormat("#.##");

				for (String goodName : goods) {
					Items.add(new twoString(goodName.trim(), "  " + df.format(price)));
					total += price;
				}
				Items.add(new twoString("TOTAL  ....", df.format(total)));

				//Update the data in arrayAdapter
				aa.notifyDataSetChanged();	
			}
		}		

	}

	/*
	 * ***********************************************
	 * Only for the emulator, because you have to 
	 * override the emulator private IP  (10.0.2.15) 
	 * by the Host IP.
	 * 
	 * Remember to use the console command 
	 * to redirect the emulator private port 
	 * to a localhost port (in the host)
	 * # telnet localhost 5554
	 *    redir add tcp:9090:9090
	 *     
	 * Comment to use in the cellular phone
	 * ***********************************************
	 */

	public static AID getAID(){
		//Only by the Emulator (This is not necessary in cellular phone)
		AID agentSender = new AID();
		agentSender.setName("AndroClient@andromeda");
		//agentSender.addAddresses("http://MYIPADDRESS:9090/");  //communication between HOST-to-HOST
		agentSender.addAddresses("http://localhost:9090/"); //communication in localhost
		return agentSender;

	}

	/*
	 * 
	 * 
	 */
	
	@Override
	public void onRestart() {
		super.onRestart();
		Log.i("AGENT", "onRestart()");
		mLockScreenRotation();
	}

	@Override
	public void onResume(){
		super.onResume();
		registerReceiver(listerEvent, filterView);
		registerReceiver(listerEvent, filterView1);
		Log.i("AGENT", "onResume()");
	}

	@Override
	public void onPause() {
		super.onPause();
		unregisterReceiver(listerEvent);
		Log.i("AGENT", "onPause()");
	}
	
	@Override
	public void onStop() {
		mfreeScreenRotation();
		Log.i("AGENT", "onStop()");
		super.onStop();
	}
	
	@Override
	public void onDestroy(){
		Log.i("AGENT", "onDestroy()");
		if (initAgent != null) stopService(initAgent);
		super.onDestroy();
	}

	// Stop the screen orientation changing during an event
	private void mLockScreenRotation(){
		switch (this.getResources().getConfiguration().orientation){
		case Configuration.ORIENTATION_PORTRAIT:
			this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
			break;
		case Configuration.ORIENTATION_LANDSCAPE:
			this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
			break;
		}
	}

	// allow screen rotations again
	private void mfreeScreenRotation(){
		this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED);	
	}


	/**
	 * These methods were used to capture the 
	 * physical key: Home, back, search, menu.
	 * 
	 */
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			return true; 
		} else{
			return super.onKeyDown(keyCode, event);
		}
		
	}
	
	
    /**
	 * These methods were used to show a drop-down menu 
	 * the Phone screen  (GUI).
	 * 
	 */    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
    	MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.layout.menu, menu);
        return true;
    }
    
    /**
	 * These methods were used to capture the click in drop-down menu 
	 * the Phone screen  (GUI).
	 * 
	 */ 
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	super.onOptionsItemSelected(item);
    	    	
        switch (item.getItemId()) {
           case R.id.exitapp: 
            	Toast.makeText(this, "Exit app!", Toast.LENGTH_LONG).show();
            	this.finish();
                break;
        }
        return true;
    }

	/**
	 * These Class were created to customize two lines of text 
	 * in the Phone Screen (GUI), which was specified in an xml 
	 * file (two_text), using the features of arrayAdapter.
	 * 
	 */
	class twoString{
		public String x1;
		public String x2;

		twoString(String _x1, String _x2){
			x1= _x1;
			x2= _x2;
		}
	}


	class twoLineAdapter extends ArrayAdapter<twoString> {
		int resource;

		public twoLineAdapter(Context _context,	int _resource, List<twoString> _items) {
			super(_context, _resource, _items);
			resource = _resource;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent){
			LinearLayout stringView;
			twoString item = getItem(position);
			String x1 = item.x1;
			String x2 = item.x2;

			if (convertView == null){
				stringView = new LinearLayout(getContext());
				String inflater = Context.LAYOUT_INFLATER_SERVICE;
				LayoutInflater vi = (LayoutInflater)getContext().getSystemService(inflater);
				vi.inflate(resource, stringView, true);
			}else{
				stringView = (LinearLayout) convertView;
			}

			TextView datax1 = (TextView)stringView.findViewById(R.id.text01);
			TextView datax2 = (TextView)stringView.findViewById(R.id.text02);
			datax1.setText(x1);
			datax2.setText(x2);

			return stringView;
		}
	}    
}